
#include "cuda_runtime.h"
#include "device_launch_parameters.h"

#include <stdio.h>
#include "time.h"
#include "windows.h"

  //const int 
#define arraySize  1000*1000
	int a[arraySize]; 
    int b[arraySize]; 
    
	int c[arraySize] = { 0 };
cudaError_t addWithCuda(int *c, const int *a, const int *b, unsigned int size);

__global__ void addKernel(int *c, const int *a, const int *b)
{
	int i = threadIdx.x+blockIdx.x*blockDim.x;
	if(i<1000*1000)
		c[i] = a[i] + b[i];		
	//for(int j=0; j<10; j++);
}

int main()
{

  
	
	for(int i=0; i<arraySize; i++)
	{
		a[i]=i+1;b[i]=10*(i+1);
	}


	LARGE_INTEGER  num;  
	long start,end,freq;  
	QueryPerformanceFrequency(&num);  
	freq=num.QuadPart;  
	QueryPerformanceCounter(&num);   
	start= num.QuadPart;   

	for(int i=0;i<arraySize;i++)
	{
			c[i]=a[i]+b[i];
			//for(int j=0; j<10; j++);
	}
	QueryPerformanceCounter(&num);   
	end= num.QuadPart;    
	printf("CPUϴִʱΪtime=%f(ms)\n",(double)(end-start)*1000/freq); 
	

    // Add vectors in parallel.
    cudaError_t cudaStatus= addWithCuda(c, a, b, arraySize);
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "addWithCuda failed!");
        return 1;
    }



    //printf("{1,2,3,4,5} + {10,20,30,40,50} = {%d,%d,%d,%d,%d}\n",c[0], c[1], c[2], c[3], c[4]);

    // cudaDeviceReset must be called before exiting in order for profiling and
    // tracing tools such as Nsight and Visual Profiler to show complete traces.
    cudaStatus = cudaDeviceReset();
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaDeviceReset failed!");
        return 1;
    }




    return 0;
}

// Helper function for using CUDA to add vectors in parallel.
cudaError_t addWithCuda(int *c, const int *a, const int *b, unsigned int size)
{
    int *dev_a = 0;
    int *dev_b = 0;
    int *dev_c = 0;
    cudaError_t cudaStatus;

    // Choose which GPU to run on, change this on a multi-GPU system.
    cudaStatus = cudaSetDevice(0);
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaSetDevice failed!  Do you have a CUDA-capable GPU installed?");
        goto Error;
    }

    // Allocate GPU buffers for three vectors (two input, one output)    .
    cudaStatus = cudaMalloc((void**)&dev_c, size * sizeof(int));
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaMalloc failed!");
        goto Error;
    }

    cudaStatus = cudaMalloc((void**)&dev_a, size * sizeof(int));
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaMalloc failed!");
        goto Error;
    }

    cudaStatus = cudaMalloc((void**)&dev_b, size * sizeof(int));
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaMalloc failed!");
        goto Error;
    }

    // Copy input vectors from host memory to GPU buffers.
    cudaStatus = cudaMemcpy(dev_a, a, size * sizeof(int), cudaMemcpyHostToDevice);
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaMemcpy failed!");
        goto Error;
    }

    cudaStatus = cudaMemcpy(dev_b, b, size * sizeof(int), cudaMemcpyHostToDevice);
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaMemcpy failed!");
        goto Error;
    }

	float time_elapsed=0;
    cudaEvent_t start,stop;
    cudaEventCreate(&start);    //Event
    cudaEventCreate(&stop);
    cudaEventRecord( start,0);    //¼ǰʱ

  // Launch a kernel on the GPU with one thread for each element.
    addKernel<<<1000, 1000>>>(dev_c, dev_a, dev_b);
    cudaEventRecord( stop,0);    //¼ǰʱ
 
    cudaEventSynchronize(start);    //Waits for an event to complete.
    cudaEventSynchronize(stop);    //Waits for an event to complete.Record֮ǰ
    cudaEventElapsedTime(&time_elapsed,start,stop);    //ʱ
    cudaEventDestroy(start);    //destory the event
    cudaEventDestroy(stop);

    printf("GPUϲִʱΪtime=%f(ms)\n",time_elapsed);

  

    // Check for any errors launching the kernel
    cudaStatus = cudaGetLastError();
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "addKernel launch failed: %s\n", cudaGetErrorString(cudaStatus));
        goto Error;
    }
    
    // cudaDeviceSynchronize waits for the kernel to finish, and returns
    // any errors encountered during the launch.
    cudaStatus = cudaDeviceSynchronize();
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaDeviceSynchronize returned error code %d after launching addKernel!\n", cudaStatus);
        goto Error;
    }

    // Copy output vector from GPU buffer to host memory.
    cudaStatus = cudaMemcpy(c, dev_c, size * sizeof(int), cudaMemcpyDeviceToHost);
    if (cudaStatus != cudaSuccess) {
        fprintf(stderr, "cudaMemcpy failed!");
        goto Error;
    }

Error:
    cudaFree(dev_c);
    cudaFree(dev_a);
    cudaFree(dev_b);
    
    return cudaStatus;
}
